'   Copyright (1998)
'
'  File Name:   drawslp.bas
'  Revisions:
'  11/27/1998 TCS Program Written
'  09/12/2000 TCS modified to allow multiple lines
'  12/15/2000 TCS added MBESendCommand "null" to allow exiting
'             without error when another command is picked
'
'  Written by tshoemaker@yahoo.com
'
'  Draws line at specified slope.
'-----------------------------------------------------------------------
' Use, modification, or distribution of this program implies that the
' user accepts all responsibility and liablility for the results.  No
' warranty of any kind is made by the author.  This program is free,
' please use it with that in mind.
'-----------------------------------------------------------------------

public drawslp_Slope#

sub main
    dim Pt as MbePoint
    dim status as integer
    dim Dist as double
    dim x1 as double
    dim x2 as double
    dim y1 as double
    dim y2 as double
    dim z1 as double
    dim z2 as double
    dim Txt as string

    MbeStartDefaultCommand
    
    actionButton = mbeOpenModalDialog (1)
    
    if (actionButton <> MBE_BUTTON_CANCEL ) then
      Do
    
        MbeSendCommand "PLACE LINE"
        MbeWritePrompt "Select First Point."
        MbeGetInput MBE_DataPointInput, MBE_ResetInput,MBE_KeyinInput,MBE_CommandInput
        
        If MbeState.inputType = MBE_DataPointInput Then
          status=MbeState.getInputDataPoint(Pt)
          x1=Pt.x
          y1=Pt.y
          z1=Pt.z
          MbeSendDataPoint Pt

          MbeWritePrompt "Select Second Point."
          MbeGetInput MBE_DataPointInput, MBE_ResetInput,MBE_KeyinInput,MBE_CommandInput
          
          If MbeState.inputType = MBE_DataPointInput Then
            status=MbeState.getInputDataPoint(Pt)
            x2=Pt.x
            y2=Pt.y
            Dist = sqr((y2-y1)^2+(x2-x1)^2)
            Pt.z=z1 + Dist*drawslp_Slope#/100.0
            MbeSendDataPoint Pt
            MbeSendReset
            MbeSendReset
          Else
            MbeSendCommand "null"  'revision 12-15-00
            MbeSendLastInput
            Exit Do
          End If
        Else
          MbeSendCommand "null"  'revision 12-15-00
          MbeSendLastInput
          Exit Do
        End If
      Loop
      If MbeState.inputType = MBE_ResetInput Then MbeStartDefaultCommand
    end if
end sub
 
