'   Copyright (2000)
'
'  File Name:   drawslp.bas
'  Revisions:
'  12/15/2000 TCS Program Written
'
'  Written by tshoemaker@yahoo.com
'
'  Draws line at specified slope to the target elevation.
'-----------------------------------------------------------------------
' Use, modification, or distribution of this program implies that the
' user accepts all responsibility and liablility for the results.  No
' warranty of any kind is made by the author.  This program is free,
' please use it with that in mind.
'-----------------------------------------------------------------------

public drawslp_Slope#
public drawslp_El#

sub main
    dim Pt1 as MbePoint  'holds first point from user
    dim Pt2 as MbePoint  'holds second point from user
    dim Pt3 as MbePoint  'calculated end point
    dim status as integer
    dim Dist12 as double   'horiz. dist. from Pt1 to Pt2
    dim dist13 as double   'horiz. dist. from Pt1 to Pt3
    dim Txt as string

    MbeStartDefaultCommand
    
    actionButton = mbeOpenModalDialog (1)
    
    If (actionButton <> MBE_BUTTON_CANCEL ) then
      Do
    
        MbeSendCommand "PLACE LINE"
        MbeWritePrompt "Select First Point."
        MbeGetInput MBE_DataPointInput, MBE_ResetInput,MBE_KeyinInput,MBE_CommandInput
        
        If MbeState.inputType = MBE_DataPointInput Then
          status=MbeState.getInputDataPoint(Pt1)
          MbeSendDataPoint Pt1

          MbeWritePrompt "Select Second Point."
          MbeGetInput MBE_DataPointInput, MBE_ResetInput,MBE_KeyinInput,MBE_CommandInput
          
          If MbeState.inputType = MBE_DataPointInput Then
            status=MbeState.getInputDataPoint(Pt2)

            'Calculate horiz. distances
            Dist12 = sqr((pt2.Y - pt1.Y)^2+(pt2.X-pt1.X)^2)
            Dist13 = (drawslp_El - Pt1.Z)/drawslp_Slope*100

            'Calculate pt3
            If (Dist13>0) Then
              Pt3.X = (pt2.X - pt1.X) * Dist13/Dist12 + pt1.X
              pt3.Y = (pt2.Y - pt1.Y) * Dist13/Dist12 + pt1.Y
              pt3.Z = drawslp_El
            End If

            MbeSendDataPoint Pt3
            MbeSendReset
            MbeSendReset
          Else
            MbeSendCommand "null"
            MbeSendLastInput
            Exit Do
          End If

        Else
          MbeSendCommand "null"
          MbeSendLastInput
          Exit Do
        End If
      Loop
    End If
end sub
 
